-- !! PUT BACK PURGE CONFIG PAGE CALL THE WAY IT SHOULD BE

-- !! "Task Options" string needs Localization in OPTIONS

-- ------------------------------------------------------------------------- --
-- Project: Executive Assistant - Custom To-Do/Task List Manager
-- Author:  VincentSDSH				
-- Version: 0.9.9h - w6.2.4
-- ------------------------------------------------------------------------- --
-- Command: /ea or /exa
-- ------------------------------------------------------------------------- --
local AddonName = ...
ExecAssist = LibStub("AceAddon-3.0"):NewAddon(AddonName, "AceEvent-3.0", "AceTimer-3.0")
ExecAssist.Dialog = LibStub("AceConfigDialog-3.0")
ExecAssist.wowVer = "6.2.4"
ExecAssist.debug = function(data, label, colorize) if ExecAssist.db.sv.debug then local r, b, g if not colorize then r=1; g=1; b=.8 elseif (label and data) then r=0; g=1; b=0 else r=1; g=0; b=0 end; local eaColon = ("::"):cf("EAblue"); DEFAULT_CHAT_FRAME:AddMessage( eaColon..("EA_debug"):cf("EAtan")..eaColon .." ".. (label and (label.." is: ") or "").. tostring(data), r, g, b); end end
local debug = ExecAssist.debug
local L = LibStub("AceLocale-3.0"):GetLocale(AddonName)

function ExecAssist:OnInitialize()
	-- Extend Plumbing ------------------------------------------------------- --
	self:extendStringFunc()

  -- Defaults -------------------------------------------------------------- --
	self.EventsRegistered = {}; self.prototype = {}
  self.prototype.Group = {
  	["id"] = "", -- self handle :: pass (hGroup) rather than (hGroup, groupID) when asking a parent to operate on the child's /reference/ not just the child (e.g., .DO ops, etc)
		["p"] = "", -- parent GroupID
		["listName"] = "Default New Group Name",
		["defaultEnabled"] = true, -- ENABLED
		["hideDays"] = {}, -- {Sun -> Sat}  
		["DO"] = {}
  }	
	self.prototype.Task = {
		["id"] = "", -- taskID
		["p"] = "",  -- parent GroupID
		["taskName"] = "Default New Task Name",
		["defaultEnabled"] = true, -- ENABLED
		["resetType"] = "Daily Automatic",	-- {Daily, Weekly, Other}
		["hideDays"] = {} -- {Sun -> Sat} Primed b/c the multiselect control returns 						
	}	
  self.icons = {
    ["defaultLDBIcon"]  = ([[Interface\Addons\%s\icons\ExecutiveAssistant_appIcon]]):format(AddonName),

  	["ldb_Complete"]    = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_on]]):format(AddonName),
  	["ldb_Incomplete"]  = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_off]]):format(AddonName),

  	["enabled"]  			  = ([[Interface\Addons\%s\icons\ExecutiveAssistant_on]]):format(AddonName),
  	["disabled"] 			  = ([[Interface\Addons\%s\icons\ExecutiveAssistant_off]]):format(AddonName),

  	["used"]  			    = ([[Interface\Addons\%s\icons\ExecutiveAssistant_used]]):format(AddonName),
  	["notused"] 			  = ([[Interface\Addons\%s\icons\ExecutiveAssistant_notused]]):format(AddonName),

  	["used_R"]  		    = ([[Interface\Addons\%s\icons\ExecutiveAssistant_used_reminder]]):format(AddonName),
  	["notused_R"] 		  = ([[Interface\Addons\%s\icons\ExecutiveAssistant_notused_reminder]]):format(AddonName),  	
  	
  	["disabledGroup"]   = ([[Interface\Addons\%s\icons\ExecutiveAssistant_disabled]]):format(AddonName),
  	["twExpanded"] 			= ([[Interface\Addons\%s\icons\ExecutiveAssistant_twExpanded]]):format(AddonName),
  	["twCollapsed"]     = ([[Interface\Addons\%s\icons\ExecutiveAssistant_twCollapsed]]):format(AddonName),
  	["ldb_Expanded_h"]  = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_Expanded_header]]):format(AddonName),  	
  	["ldb_Collapsed_h"] = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_Collapsed_header]]):format(AddonName),
  	["ldb_Expanded"]    = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_Expanded]]):format(AddonName),  	
  	["ldb_Collapsed"]   = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_Collapsed]]):format(AddonName),
  	["ldb_OneChar"]     = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_showOne]]):format(AddonName),
  	["ldb_AllChar"]     = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_showAll]]):format(AddonName),
  	["ldb_tt_PGT"]      = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_PGT]]):format(AddonName),
  	["ldb_tt_GTP"]      = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_GTP]]):format(AddonName),
  	["ldb_showGroups"]  = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_showGroups]]):format(AddonName),
  	["ldb_hideGroups"]  = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_hideGroups]]):format(AddonName),
  	["ldb_showALLgroups"] = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_showALLGroups]]):format(AddonName),
  	["ldb_ShowOnlySelectedGroup"] = ([[Interface\AddOns\%s\icons\ExecutiveAssistant_ShowOnlySelectedGroup]]):format(AddonName),
  	["tw_config"] = ([[Interface\Addons\%s\icons\ExecAssist_Config]]):format(AddonName),
  	["tw_config_push"] = ([[Interface\Addons\%s\icons\ExecAssist_Config_push]]):format(AddonName),
  } 

  -- Setup AceDB
	self.DBDefaults = {
		-- why GLOBAL vs PROFILE or CHAR for charStem data? Profiles coonotate being able to 'change hats' mid-session 
		-- 		which would mean 'being someone else' in the context of this addon, making it confusing to say the least,
		--    or to swap to different sub-sets of actions, which is understandable but a less-in-control way of doing it.
		-- 		Moreover, I'd still have to dig into the .sv[*] end of the db var to find the other profiles to list out
		--  	the other characters for the GTP orientation or the full PGT orientation.
		-- This same thinking applies to placing the data in Char. It doesn't make accessing it that much easier
		--  	(though it would be technically faster/more-efficient when only looking at the current character, that
		-- 		measurement is in miniscule fractions of a milisecond second) and I'd still have to traverse the .sv[*]
		--  	end of the AceDB structure when looking at all chars.
		-- Doing it this way means I can have a standard method (charStem vs self.db.char & self.db.sv.char) and
		-- 		have no chance of running afoul of some profile-related giggery-pokery of which I might be unaware.
		-- The db.char route is used for things I found a need to be character-specific, depending on the class &
		-- 		addons used, usage might differ (e.g., minimap button position & hide/show; task-window usage & position
		-- 		(heavy user) vs ldb-tooltip (alt with few tasks) )
		["char"] = {
    	["DBIconTable"] = { ["hide"] = false },
    	["useTaskWindow"] = true,
			["useDataBrokerTooltip"] = true,   	
    	["map"] = {["char"] = nil, ["TW"] = nil, ["GTP"] = nil},
		},
    ["global"] = {
    	["Options"] = {
    		["AllowAPI"] = false,
    		["showLoginAlerts"] = false,
    		["WeeklyResetDay"] = 3, 
    		["DailyResetTime"] = 6,
				["cfg_groupColor"] = {["r"] = 1, ["g"] = 1, ["b"] = 0},
				["ldbIcon"] = "defaultLDBIcon",
				["SaveCollapseMap"] = true,
    	},
    	["acctwideStem"] = { -- subbing agg to make space for possible future metadata...
				["agg"] = { -- Not /technically/ an agglomeration since only taskID completion tags would be in play 
				}    	
    	},
			["charStem"] = {
			},
			["groupStem"] = {
				["garden"] = { -- Starting Point (DO) for Groups (it was this or a hidden faux-'parent')
				},
				["agg"] = { -- The Great Agglomeration, groupIDs and taskIDs >> groupID.DO = Display Order
					["garden"] = { -- Starting Point (DO) for Groups (it was this or a hidden faux-'parent')
						["id"] = "garden",
						["listName"] = "garden",
						["DO"] = {}
					},				
				},
			},
			["taskWindow"] = {
				["locked"] = false,
				["useDragFrame"] = true,
				["pos"] = {
					["idx"] = 1,
					["relTW"] = "CENTER",
					["posW_rel"] = "CENTER",
					["posW_relP"] = "CENTER",
					["xOff"] = 0,
					["yOff"] = 0,
				},
				["HideEmptyGroups"] = true,
				["defaultCollapse"] = false,
				["opacity_mouseover"] = 1,
				["opacity_faded"] = 1,
				["hideincombat"] = false,
				["ButtonPos"] = 2,
				["useMouseoverHighlight"] = true,
				["useCounts_onHeaders"] = true,
				["displayType_onHeaders"] = 1,
				["rightMouse_togglesShowChecked"] = true,
				["showChecked"] = true,
				["enableTooltipTooltips"] = true,
				["style"] = {
					["background"] = "Solid", -- "Blizzard Tooltip",
					["border"] = "Blizzard Tooltip",
					["bgcolor"] = {["r"] = 0.01, ["g"] = 0.01, ["b"] = 0.01},
					["bdrcolor"] = {["r"] = 0.01, ["g"] = 0.01, ["b"] = 0.01},
				},				
			},
			["tooltip"] = {
				["HideEmptyGroups"] = true,
				["defaultCollapse"] = false,			
				["rightMouse_togglesShowChecked"] = true,
				["showChecked"] = true,
				["defaultExpandSelf"] = true,
				["OnlyCurrentChar"] = true,				
				["ShowServerNames"] = true,
				["useMouseoverHighlight"] = true,
				["default_tooltipType"] = "PGT",
				["standard_font"] = "Friz Quadrata TT",
				["standard_size"] = 10,
				["header_font"] = "Friz Quadrata TT",
				["header_size"] = 12,
				["snowflake_font"] = "Friz Quadrata TT",
				["snowflake_size"] = 9,
				["useCounts_onHeaders"] = true,
				["displayType_onHeaders"] = 1,
				["useCounts_onLDB"] = true,
				["displayType_onLDB"] = 1,
				["default_GroupDisplayMode_PGT"] = 1, -- default & override group display mode
				["ShowGroupNames_PGT"] = true,				-- group display modes
				["ShowAllGroups_PGT"] = true,					-- group display modes
				["ShowOnlySelectedGroup_PGT"] = true,	-- group display modes
				["HideGroupNames_PGT"] = true,				-- group display modes
				["default_GroupDisplayMode_GTP"] = 1, -- default & override group display mode
				["ShowAllGroups_GTP"] = true,					-- group display modes
				["HideGroupNames_GTP"] = true,				-- group display modes
				["tooltipButtonPos"] = 1,
  
				["color_Group"]      = {["r"] = 0.78, ["g"] = 0.61, ["b"] = 0.43},
				["color_TaskName"]   = {["r"] = 1,    ["g"] = 1,    ["b"] = 1   },
				["color_taskCounts"] = {["r"] = 0.43, ["g"] = 0.61, ["b"] = 0.78},

				["enableTooltipTooltips"] = true,
				["SM"] = { -- Style Manager
					["acctwide"] = {
						["useStyle"] = true,
						["useText"] = 2,
						["useText_text"] = "*",
						["useColor"] = 2,						
						["color"] = {["r"] = 0, ["g"] = 0.94, ["b"] = 0.94},
					},
					["purgable"] = {
						["useStyle"] = true,
						["useText"] = 2,
						["useText_text"] = "(p)",
						["useColor"] = 2,		
						["color"] = {["r"] = 1, ["g"] = 0, ["b"] = 0.5},
					},
					["hidden"] = {
						["useStyle"] = true,
						["useText"] = 2,
						["useText_text"] = "(i)",
						["useColor"] = 2,		
						["color"] = {["r"] = 0.73, ["g"] = 0.61, ["b"] = 0.78},
					},
					["cmdLineTarget"] = {
						["useStyle"] = true,
						["useText"] = 2,
						["useText_text"] = "(c)",
						["useColor"] = 2,		
						["color"] = {["r"] = 0.33, ["g"] = 0.54, ["b"] = 0.52},
					},
					["snowflake"] = {
						["useStyle"] = true,
						["useText"] = 2,
						["useText_text"] = "[Z]",
						["useColor"] = 2,		
						["color"] = {["r"] = 1, ["g"] = 0.49, ["b"] = 0.4},
					},
				},
			},
			["clickmapOrder"] = {"HELP", "CONFIG", "CLICKMAP", "ClickMap_Config", "TACM", "STYLEMGR", "TOOLTIP CONFIG", "TASKWIN CONFIG", "RESET", "reset_Manual", "ToggleTaskWindow", "ShowDataBrokerTT", "ToggleTooltipTips", "purgePurgables" },
			["clickmap"] = { -- LDB -- since it's not user alterable or put in the sv file, could move the full clickmap into this...but that would make any 3rd-party extensibility problematic at best; easy enough to stuff in for 1-index maint if the API idea is shelved
				["CONFIG"] 				   = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = (L.clickmap_CONFIG_name):format(L.appName),
					["desc"] = (L.clickmap_CONFIG_desc):format(L.appName),
					["func"] = function() ExecAssist:doLoadConfig() end,
				},
				["HELP"]				 	   = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = (L.clickmap_HELP_name):format(L.appName),
					["desc"] = (L.clickmap_HELP_desc):format(L.appName),
					["func"] = function() ExecAssist:doLoadHelp() end,
				},
				["CLICKMAP"] 			   = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = L.clickmap_CLICKMAP_name,
					["desc"] = L.clickmap_CLICKMAP_desc,
					["func"] = function() ExecAssist:doLoadClickMap() end,
				},
				["TACM"] 					   = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = L.clickmap_TACM_name,
					["desc"] = L.clickmap_TACM_desc,
					["func"] = function() ExecAssist:doLoadTaskMaint() end,
				},
				["STYLEMGR"] 			   = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = L.clickmap_STYLEMGR_name,
					["desc"] = L.clickmap_STYLEMGR_desc,
					["func"] = function() ExecAssist:doLoadSyleMgr() end,
				},
				["TOOLTIP CONFIG"]   = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = L.clickmap_TOOLTIPCONFIG_name,
					["desc"] = L.clickmap_TOOLTIPCONFIG_desc,
					["func"] = function() ExecAssist:doLoadTooltipConfig() end,
				},
				["TASKWIN CONFIG"]   = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = L.clickmap_TASKWINCONFIG_name,
					["desc"] = L.clickmap_TASKWINCONFIG_desc,
					["func"] = function() ExecAssist:doLoadTaskWindow() end,
				},
				["RESET"] 				   = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = L.clickmap_RESET_name,
					["desc"] = L.clickmap_RESET_desc,
					["func"] = function() ExecAssist:doLoadResetOpts() end,
				},
				["reset_Manual"] 	   = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = L.clickmap_reset_Manual_name,
					["desc"] = L.clickmap_reset_Manual_desc,
					["func"] = function() ExecAssist:resetTasks(nil, nil, true) end,
				},
				["purgePurgables"]   = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = L.clickmap_purgePurgables_name,
					["desc"] = (L.clickmap_purgePurgables_desc):format(L.appName),
					["func"] = function() ExecAssist:resetTasks(nil, nil, nil, true) end, -- purge purgables
				},
				["ToggleTaskWindow"] = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = L.clickmap_ToggleTaskWindow_name,
					["desc"] = L.clickmap_ToggleTaskWindow_desc,
					["func"] = function() ExecAssist:doUseTaskWindow() end,
				},
				["ShowDataBrokerTT"] = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = L.clickmap_ShowDataBrokerTT_name,
					["desc"] = L.clickmap_ShowDataBrokerTT_desc,
					["func"] = function() ExecAssist:doShowDataBrokerTooltip() end,
				},
				["ClickMap_Config"]  = {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = L.clickmap_CLICKMAPconfig_name,
					["desc"] = L.clickmap_CLICKMAPconfig_desc,
					["func"] = function() ExecAssist:configureClickMap() end,
				},
				["ToggleTooltipTips"]= {
					["code"] = nil, ["m"] = false, ["s"] = nil, ["a"] = nil, ["c"] = nil, ["notify"] = true,
					["name"] = L.clickmap_ToggleTooltipTips_name,
					["desc"] = L.clickmap_ToggleTooltipTips_desc,
					["func"] = function() ExecAssist:toggleTooltipTips() end,
				},
			},
			-- ["clickmapGates"] = { -- function gates (unimplemented feature / user confusion generator
			-- 	["togg_TW_showCompleted"] = {["m"] = "RightMouse", ["s"] = nil,  ["a"] = nil, ["c"] = nil},
			-- 	["togg_TW_locked"] = {["m"] = "LeftButton", ["s"] = true,  ["a"] = nil, ["c"] = nil},
			-- },
    },
  }
  self.db = LibStub("AceDB-3.0"):New("ExecAssistDB", self.DBDefaults, true)    

	-- Prime char vars and charStem
	self.userCurrent = UnitName("player").." - "..GetRealmName(); self.userConfigDisplay = self.userCurrent
 	if not self.db.global.charStem[self.userCurrent] then self.db.global.charStem[self.userCurrent] = {["agg"] = {}} end -- new user, establish agglomeration
	debug("* Debugging Mode Active *") -- dev sanity check
	
	-- Register Options ------------------------------------------------------ --
	self:regOptions()

  -- Commandline ----------------------------------------------------------- --
	local cmdLine = {
		type = "group",
		name = L.appName.."CmdLine",
		args = {
      config = {
        type = "execute",
        name = "Config",
        desc = L.AddonConfiguration,
        func = function() ExecAssist:doLoadConfig() end,
        order = 0
      },
      manage = {
        type = "execute",
        name = "",
        desc = L.CommandLineHelp_manage,
        func = function() ExecAssist:doLoadTaskMaint() end,
        order = 2
      },
      task = {
        type = "execute",
        name = "",
        desc = L.CommandLineHelp_task,
        func = function(...) ExecAssist:doAddPurgableTask(...) end,
        order = 2
      },
      mytask = {
        type = "execute",
        name = "",
        desc = L.CommandLineHelp_mytask,
        func = function(...) ExecAssist:doAddPersonalPurgableTask(...) end,
        order = 3
      },
      setgroup = {
        type = "execute",
        name = "",
        desc = L.CommandLineHelp_setgroup,
        func = function(...) ExecAssist:doResetTargetGroup(...) end,
        order = 5
      },
      debug = {
        cmdHidden = true, 
        type = "execute",
        name = "Toggle Debug",
        desc = "Toggles Debug Mode",
        func = function() ExecAssist:doDebuggingMode() end,
        order = 3
      },      
    }
  }
 	LibStub("AceConfig-3.0"):RegisterOptionsTable(AddonName.." CmdLine", cmdLine, {"ea", "exa"})

  -- libDataBroker and DBIcon ---------------------------------------------- --
  self.meatPopcicle = self:ldb_ObjectCreate()
  LibStub("LibDBIcon-1.0"):Register(AddonName, self.meatPopcicle, self.db.char.DBIconTable) 
end

function ExecAssist:OnEnable()
	local sdbg = self.db.global
	-- char prime
	sdbg.charStem[self.userCurrent].charClass = select(2, UnitClass("player")) -- reset each time in case a char is deleted and remade w/ new class and same name
	self:mkCharList() -- make Alphabetized Character List
	
	-- Check for Resets & set timer
	self:doResetCheck()
	self.timers = { ["doResetCheck"] = self:ScheduleRepeatingTimer( "doResetCheck", (5*60) ) } -- self:CancelTimer(self.timers.doResetCheck) 

	-- reset At Login tasks
	self:resetTasks(nil, nil, nil, nil, true)
	
	-- Load the DB into Options Tables
	self:loadGroups_toOptionsTable()		
	
	-- Marker Cache
	if not self.markerCache then -- saves a crapton of repeated fetches
	  local dx = {["D"] = "cream", ["W"] = "grass", ["M"] = "sky", ["P"] = "purple", ["L"] = "dullRed", ["C"] = "lightgray", ["R"] = "afternoon"}	-- marker index for Daily/Weekly/Manual reset types	
		self.markerCache = {}
		for k, v in pairs(dx) do self.markerCache[k] = self:Marker(v) end -- converts Crayon hex values to percentage colors
	end		

	-- collapse map
	self:pushCollapseMap()

	-- Load the Task Window if needed
	if self.db.char.useTaskWindow then 
		self:CreateTaskWindow() 
		if self:getHandle_TaskWindow().hideincombat then self:registerCombatEvents(true) end -- Register Events
	end

	-- Update LDB if needed
	if sdbg.tooltip.useCounts_onLDB and not self.taskWindow then self:ldb_refreshCounts() end
	
	-- tooltip mode pool
	local I = self.icons
	self.mode_PGT = sdbg.tooltip.default_GroupDisplayMode_PGT
	self.mode_GTP = sdbg.tooltip.default_GroupDisplayMode_GTP
	self.modePool = { 
		[1] = {["b"] = "ShowGroupNames", 			  ["i"] = self:mkLink(I.ldb_showGroups, 16),    				 ["PGT"] = true; ["GTP"] = false},
		[2] = {["b"] = "ShowAllGroups", 				["i"] = self:mkLink(I.ldb_showALLgroups, 16), 				 ["PGT"] = true; ["GTP"] = true },
		[3] = {["b"] = "ShowOnlySelectedGroup", ["i"] = self:mkLink(I.ldb_ShowOnlySelectedGroup, 16),  ["PGT"] = true; ["GTP"] = false}, 
		[4] = {["b"] = "HideGroupNames", 			  ["i"] = self:mkLink(I.ldb_hideGroups, 16), 					   ["PGT"] = true; ["GTP"] = true }
	}

	-- Brand New User, Setup Initial Tasks and Clickmapping
	if not sdbg.IsOldHat then
		local groupStem = sdbg.groupStem
		local groupID = self:AddGroup(L.NewUserTasks, groupStem.agg["garden"])
		local hGroup = groupStem.agg[groupID]
		
		hGroup.cmdLineTarget = true
		groupStem.cmdLineTarget = hGroup.id
		
		local function newTask(taskName, suppressRefresh_cmdline)
			local hTask = self:AddTask(hGroup, nil, suppressRefresh_cmdline)			
			hTask.taskName = taskName
			hTask.resetType = self.optValues.ResetTypes[ 3 ]
			hTask.isAcctWide = true
		end

		local hTask = sdbg.groupStem.agg[hGroup.DO[1]]
		hTask.taskName = L.BrandNewUserTask_0
		hTask.resetType = self.optValues.ResetTypes[ 3 ]
		hTask.isAcctWide = true

		newTask(L.BrandNewUserTask_1,  true)
		newTask(L.BrandNewUserTask_2,  true)
		newTask(L.BrandNewUserTask_3,  true)
		newTask(L.BrandNewUserTask_4,  true)
		newTask(L.BrandNewUserTask_5,  true)
		newTask(L.BrandNewUserTask_6,  true)
		newTask(L.BrandNewUserTask_7,  true)
		newTask(L.BrandNewUserTask_8,  true)
		newTask(L.BrandNewUserTask_9,  true)
		newTask(L.BrandNewUserTask_10, true)
		newTask(L.BrandNewUserTask_11, false) -- initial run has Task Window enabled
		
		-- Update GroupMaintenance var, so new tasks show in the list
		self:loadGroups_toOptionsTable()	

		hGroup.cmdLineTarget = false
		groupStem.cmdLineTarget = nil		
		
		-- inject defaults into the ClickMap
		local cm = self.db.global.clickmap
		cm["CONFIG"]["code"] = "Lm"; cm["CONFIG"]["m"] = "LeftButton"; cm["CONFIG"]["notify"] = false
		cm["TACM"]["code"] = "Rm"; cm["TACM"]["m"] = "RightButton"; cm["TACM"]["notify"] = false
		cm["HELP"]["code"] = "Rms"; cm["HELP"]["m"] = "RightButton"; cm["HELP"]["s"] = true; cm["HELP"]["notify"] = true
		cm["ClickMap_Config"]["code"] = "Rmsc"; cm["ClickMap_Config"]["m"] = "RightButton"; cm["ClickMap_Config"]["s"] = true; cm["ClickMap_Config"]["c"] = true; cm["ClickMap_Config"]["notify"] = true

		sdbg.IsOldHat = true
	end

	-- establish the ClickMap
	self:build_clickmapServiceIndex(true) -- enable Verbose mode to alert the user of problems
	self:build_clickmapOptions() 					-- builds options dynamically from DBDefaults

end

 -- Time and Reset funcs --
function ExecAssist:doResetCheck()
	local sdbg = self.db.global
	-- New Feature Timer Trap -------------------------------------------------------------- --
	if not sdbg.lastMidnightReset then sdbg.lastMidnightReset = self:happyMidnight(time() ) end
 	if not sdbg.lastDailyReset    then sdbg.lastDailyReset    = self:happyDaily(   time() ) end
	if not sdbg.lastWeeklyReset   then sdbg.lastWeeklyReset   = self:happyWeekly(  time() ) end
	-- -------------------------------------------------------------- New Feature Timer Trap --

	-- Warp the current time back the contextual # of days. If rc > 0 tasks need to be reset
	if time() - sdbg.lastMidnightReset                            > 0 then self:resetTasks(nil, nil, nil, nil, nil, true, true) end
	if difftime( self:timeWarp(time(), 1), sdbg.lastDailyReset )  > 0 then self:resetTasks(true) end
	if difftime( self:timeWarp(time(), 7), sdbg.lastWeeklyReset ) > 0 then self:resetTasks(nil, true) end
end
-- normalizing the execution-time makes the comparitor a hard-trigger; wonder if there are n-day resetables worth worrying about -- debug( date("%Y-%m-%d %H:%M:%S", timedateObj) )
function ExecAssist:timeWarp(oriTime, daysToWarp)	return ( oriTime - (daysToWarp * 86400) ) end -- could have done last+(n*86400) but RHPS
function ExecAssist:happyMidnight(oriTime, Options_SetExplicitDay)
	-- returns midnight of the date given																-- returns Midnight Tomorrow (00:00am)
	local t
	if Options_SetExplicitDay then
		t = date("*t", oriTime) -- exact time
	else
		t = date("*t", oriTime + 86400) -- pushes 24hrs
	end 
	t.hour = 0 -- set happy hour
	t.min  = 0 -- set happy minute
	t.sec  = 0 -- set happy seconds
	return time(t)
end
function ExecAssist:happyWeekly(oriTime) -- Normalizes a time numeric to the last WeeklyResetDay (perfect comparitor)
	local real_weeklyDoW = date("*t", oriTime).wday -- find the oriTime day-of-week
	local walkbackDays = 0	                 				 -- # days that real_ needs to wind back to become perfect_
	local WeeklyResetDay = self.db.global.Options.WeeklyResetDay -- get proper weekly reset day
	
	if WeeklyResetDay == real_weeklyDoW then 							-- today = weekly reset day
		walkbackDays = 0
	elseif WeeklyResetDay < real_weeklyDoW then								
		walkbackDays = real_weeklyDoW - WeeklyResetDay			-- week has not wrapped
	else
		walkbackDays = (7-WeeklyResetDay) + real_weeklyDoW	-- week has wrapped
	end

	return self:happyTime( oriTime - (walkbackDays * 86400) ) -- adjust the requsite # of days, normalize the time of day, then return
end
function ExecAssist:happyDaily(oriTime)  -- Normalizes a time numeric to the DailyResetTime (perfect comparitor)
	-- if earlier than the reset-time would be on this date, adjust the date to yesterday and apply the reset time
	if difftime( time(), self:happyTime(time())  ) < 0 then
		return self:happyTime(self:timeWarp(oriTime, 1))
	else
		return self:happyTime(oriTime)
	end	
end
function ExecAssist:happyTime(oriTime)	 -- Inserts the user selected Reset Time into the time numeric
	local s_DailyResetTime = self.optValues.ResetTimesList[self.db.global.Options.DailyResetTime]
	local t = date("*t", oriTime)       -- get a table of Time numeric, time() needs this table structure to reconstruct  a time numeric
	t.hour = s_DailyResetTime:sub(1, 2) -- set happy hour
	t.min  = s_DailyResetTime:sub(4)    -- set happy minute
	t.sec  = 0 													-- set happy seconds
	return time(t)											-- return happy time, with apologies to Delores Herbig
end
function ExecAssist:resetTasks(resetDaily, resetWeekly, resetManual, purgePurgables, resetAtLogins, resetReminder, resetCalendar)
	local sdbg = self.db.global
	local charStem_base = sdbg.charStem
	local aggStem = sdbg.groupStem.agg
	local ResetTypes = self.optValues.ResetTypes -- 1=D, 2=W, 3=M, 4=P, 5=L, 6=C, 7=R (C=cal to purge, R=Cal to ReCal)
	local self_happyMidnightToday = self:happyMidnight(time(), true)

	local function sendAlerts()
		if resetDaily     then self:alert(L.resetAlert_resetDaily) 		 end
		if resetWeekly    then self:alert(L.resetAlert_resetWeekly) 	 end
		if resetManual    then self:alert(L.resetAlert_resetManual) 	 end
		if purgePurgables then self:alert(L.resetAlert_purgePurgables) end
		if resetAtLogins  then self:alert(L.resetAlert_resetAtLogins)  end
		if resetReminder  then self:alert(L.resetAlert_resetReminder)  end
		if resetCalendar  then self:alert(L.resetAlert_resetCalendar)  end
	end

	local function reset_ifInScope(hTask_cS, taskID) -- cS=charStem
		-- This handles PER-CHARACTER .checked field related activities. 
		-- DATE-RELATED activties (Calender Automatic, Reminder) are handled AFTER
		local hTask = aggStem[taskID]
	
		if hTask_cS.checked then -- uncheck the .checked			
			if (resetDaily    and hTask.resetType == ResetTypes[1]) or
			   (resetWeekly   and hTask.resetType == ResetTypes[2]) or
			   (resetManual   and hTask.resetType == ResetTypes[3]) or
			   (resetAtLogins and hTask.resetType == ResetTypes[5]) or 
			   (resetReminder and hTask.resetType == ResetTypes[6]) then -- [6] MIGHT be converted from something else and .checked, better safe than sorry
						hTask_cS.checked = nil
			elseif purgePurgables and hTask.resetType == ResetTypes[4] then
				self:DeleteTask(hTask, aggStem[hTask.p].G) -- hTask & parent Geneaology for hardPrune()
				-- -----------------------------------------				
			elseif resetCalendar and hTask.resetType == ResetTypes[7] then
				if hTask.resetDate_Next <= self_happyMidnightToday then
					hTask_cS.checked = nil
				end
				-- ------------------------------------------	
			end
			
		end
	end
	 
	-- Char Level Scans
	for charName, charStem in pairs(charStem_base) do		 -- character-level completes
		for itemID, hItem in pairs(charStem.agg) do        -- agg=agglomeration
			if itemID:isTask() then 
				reset_ifInScope(hItem, itemID) -- charStem entries don't carry .id & purged purgables need to find the actual task entry hTask to nix & prune
			end
		end
	end

	for itemID, hItem in pairs(sdbg.acctwideStem.agg) do -- account-wide completes (always items)
		reset_ifInScope(hItem, itemID)
	end
	
	-- Task Level Scans (Date-Related Activities)
	if resetReminder or resetCalendar then
		for itemID, hItem in pairs(aggStem) do        -- agg=agglomeration	
			if itemID:isTask() then
				if resetReminder and hItem.resetType == ResetTypes[6] then
					if hItem.resetDate_Next <= self_happyMidnightToday then hItem.resetType = ResetTypes[4] end
				elseif resetCalendar and hItem.resetType == ResetTypes[7] then
					if hItem.resetDate_Next <= self_happyMidnightToday then
						-- Advance the _Next date to one in the future; then set _Last to 'previous cycle'
						local paranoia = 0
	 					while (hItem.resetDate_Next <= self_happyMidnightToday) and (paranoia < 100) do
	 						paranoia = paranoia + 1 
	 						hItem.resetDate_Next = hItem.resetDate_Next + (86400 * hItem.offsetDays)
	 					end
	 					hItem.resetDate_Last = hItem.resetDate_Next - (86400 * hItem.offsetDays)
	 					if paranoia >= 100 then self:alert(L.paranoia_Alert..hItem.taskName) end
					end
				end
			end
		end
	end
	
	-- alerts	
	if ExecAssist.notLoginReset then sendAlerts() 
	else ExecAssist.notLoginReset = true; 
		if sdbg.Options.showLoginAlerts then sendAlerts() end 
	end

	-- reset runtimes
	if resetDaily     then sdbg.lastDailyReset  = self:happyDaily(  time() )  end
	if resetWeekly    then sdbg.lastWeeklyReset = self:happyWeekly( time() )  end
	if resetReminder or resetCalendar then sdbg.lastMidnightReset = self:happyMidnight( time() )  end

	if self.taskWindow then self:UpdateWindow() end -- check for active TaskWindow rather than sdbc.useTaskWindow b/c this will run once before the TW is loaded
end
 
-- Click-Map (active) --
local clickmapServiceIndex = {}
function ExecAssist:get_clickmapService(cmSvcTag) return self.db.global.clickmap[cmSvcTag] end -- used in building options

function ExecAssist:isBusy_clickmapServiceHandle(mouse, shift, alt, ctrl) 
	return clickmapServiceIndex[self:formatClick(mouse, shift, alt, ctrl)] 
end

function ExecAssist:formatClick(mouse, shift, alt, ctrl)	return (mouse == "LeftButton" and "Lm" or "Rm")..(shift and "s" or "")..(alt and "a" or "")..(ctrl and "c" or "") end
function ExecAssist:build_clickmapServiceIndex(verbose)
	local cmStem = self.db.global.clickmap
	clickmapServiceIndex = {} 
	for cmSvcTag, SvcOpts in pairs(cmStem) do
		if SvcOpts.m then -- m=add since all click kinda need a mouse
			if verbose then
				local isBusy = self:isBusy_clickmapServiceHandle(SvcOpts.m, SvcOpts.s, SvcOpts.a, SvcOpts.c)
				if isBusy then
					self:alert( (L.ClickMapAlert):format(
							(SvcOpts.m..(SvcOpts.s and " +"..L.cm_shift_name or "")..(SvcOpts.a and " +"..L.cm_alt_name or "")..(SvcOpts.c and " +"..L.cm_ctrl_name or "")):cf("EAblue", "cream"),
							(cmStem[isBusy].name):cf("EAtan", "cream")
						)	
					)
				return true -- isBusy=true
				end
			end
			clickmapServiceIndex[self:formatClick(SvcOpts.m, SvcOpts.s, SvcOpts.a, SvcOpts.c)] = cmSvcTag			
		end
	end
	
end
function ExecAssist:ldbClickMap(mouse, shift, alt, ctrl) 
	local userRequestedAction
	local clickmapService = clickmapServiceIndex[self:formatClick(mouse, shift, alt, ctrl)]
	local cm = self.db.global.clickmap
	if clickmapService then
		userRequestedAction = cm[clickmapService]
		if cm[clickmapService].notify then self:alert(L.cm_running..userRequestedAction.name) end
		userRequestedAction.func()
	end	
	-- Sure, I could have gotten the clickmapService tag and just if/elseif-ed my way through, but that's dead easy
	-- and I'd never used this type of estensible-friendly structure in quite this way before, and if EA is ever back-ported 
	-- to a modular design or I get my druthers and make a click-map library or allow 3rd party inserted tasks...hey, 
	-- it's 2am and Rammstein, Mozart, and Apollo Four Forty only go so far to keeping you sane.	
end
-- Click-Map (passive) -- 
--[[ function ExecAssist:(opGate, mouse, shift, alt, ctrl) Unimplemented Feature/User-Confusion-Generator
function ExecAssist:(opGate, mouse, shift, alt, ctrl)
	local gate = self.db.global.clickmapGates[opGate]
	if gate then
		if self:formatClick(gate.m, gate.s, gate.a, gate.c) == self:formatClick(mouse, shift, alt, ctrl) then return true
		else return false
		end	
	else return false	
	end
end 
--]]

	-- simple actions
function ExecAssist:doDebuggingMode() ExecAssist.db.sv.debug = not ExecAssist.db.sv.debug; ReloadUI() end

function ExecAssist:doOpenConfigWindow(page) PlaySound("igMainMenuOptionCheckBoxOn"); self.Dialog:Open(self.opts.f_reg); self.Dialog:SelectGroup(self.opts.f_reg, page); self.Dialog.OpenFrames[self.opts.f_reg]:SetStatusText((L.statusText):cf("cream"):format(L.appName:cf("EAtan"), GetAddOnMetadata(AddonName, 'Version'):cf("grass", "cream"),L.authorName:cf("EAtan"))) end
function ExecAssist:doLoadConfig()         self:doOpenConfigWindow(self.opts.f_MainOpts)   end
function ExecAssist:doLoadHelp() 					 self:doOpenConfigWindow(self.opts.f_Help)       end
function ExecAssist:doLoadClickMap() 			 self:doOpenConfigWindow(self.opts.f_ClickMap)   end
function ExecAssist:doLoadSyleMgr() 			 self:doOpenConfigWindow(self.opts.f_StyleMgr)   end
function ExecAssist:doLoadTaskMaint() 		 self:doOpenConfigWindow(self.opts.f_TaskMaint)  end
function ExecAssist:doLoadTooltipConfig()  self:doOpenConfigWindow(self.opts.f_ToolTip)  	 end
function ExecAssist:doLoadTaskWindow() 		 self:doOpenConfigWindow(self.opts.f_TaskWindow) end
--		self.opts.f_CmdLine Intentionally Left Blank (not in clickmap and no reason it should be)
function ExecAssist:doLoadResetOpts()      self:doOpenConfigWindow(self.opts.f_ResetOpts)  end
function ExecAssist:doUseTaskWindow(mode)
	local sdbc = self.db.char
	if not mode then mode = not sdbc.useTaskWindow end -- allows toggle from databroker obj and set from config

	sdbc.useTaskWindow = mode; 
	if mode then
		if not self.taskWindow then self:CreateTaskWindow() end
		self:registerCombatEvents(self:getHandle_TaskWindow().hideincombat)
		self.taskWindow:Show()
	else
		if self.taskWindow and self.taskWindow:IsShown() then self.taskWindow:Hide() end
		self:registerCombatEvents(false)
		self.taskWindow=nil
	end	
	
end
function ExecAssist:doShowDataBrokerTooltip()
	self:displayTooltip(self.h_meatPopcicle, true)
end
function ExecAssist:toggleTooltipTips()	local ttStem = self.db.global.tooltip; ttStem.enableTooltipTooltips = not ttStem.enableTooltipTooltips end


 -- libDataBroker create func
function ExecAssist:ldb_ObjectCreate()
	return LibStub("LibDataBroker-1.1"):NewDataObject(AddonName, {
		type = 'data source',
		label = L.appName, 
		text = "", 	
		icon = self.icons[ExecAssist.db.global.Options.ldbIcon],
			-- can have EITHER OnTooltipShow OR OnEnter, not both --> OnTooltipShow = function(tooltip) end				

		OnEnter = function(self) ExecAssist:displayTooltip(self) end, -- self in this context is the ldbObject		
    -- OnLeave = function(self) end,
				
		OnClick = function(self, button) ExecAssist.h_meatPopcicle = self; ExecAssist:ldbClickMap(button, IsShiftKeyDown(), IsAltKeyDown(), IsControlKeyDown()) end,
	})
end

 -- Task Window Related Combat Events
function ExecAssist:registerCombatEvents(combatEventsEnabled)
	if combatEventsEnabled then
	  self:Register("PLAYER_REGEN_DISABLED", "EVENT_combatStart")
  	self:Register("PLAYER_REGEN_ENABLED",  "EVENT_combatEnd")	
	else
	  self:Unregister("PLAYER_REGEN_DISABLED")
  	self:Unregister("PLAYER_REGEN_ENABLED")
	end
end
function ExecAssist:EVENT_combatStart() if self.taskWindow then self.taskWindow:Hide() end end
function ExecAssist:EVENT_combatEnd()   if self.taskWindow then self.taskWindow:Show() end end

 -- purgatorium
function ExecAssist:getFreshTaskStem()
	local groupStem = self.db.global.groupStem	
	if groupStem.cmdLineTarget ~= nil then
		if groupStem.agg[groupStem.cmdLineTarget] then
			local hTask = ExecAssist:AddTask(groupStem.cmdLineTarget, nil, true)
			return hTask
		else
			self:alert(L.cm_unableToFindGroup)
		end
	else
		self:alert(L.cm_NoTagetSelected)
	end
end

local function getArgTable(data)
	local data, argT, sendTo = data:trim(), {}
	local validArgs = {["+"] = {["+aw"]=true, ["+daily"]=1, ["+weekly"]=2, ["+manual"]=3}, [">"] = true}

	local function getNextArg(data)
		local nextArg, validArg
		local f = data:find(" ")
		if f then
			nextArg = data:sub(1,f-1)
			data = data:sub(f+1):trim()
			validArg = true
		else
			nextArg = data
			data = ""
			validArg = true
		end
		return nextArg, data, validArg -- if abort, nextArg is invalid arg
	end

	local validArg = true
	while validArg and #data > 2 and validArgs[data:sub(1,1)] do -- smallest possible arg = 3 (+aw)
		local nextArg
		nextArg, data, validArg = getNextArg(data)
		if validArg then
			if nextArg:sub(1,1) == ">" then
				local charStem_base = ExecAssist.db.global.charStem
				nextArg = nextArg:sub(2):lower()
				for charName, charStem in pairs(charStem_base) do
					if nextArg == charName:sub(1, charName:find(" ")-1):lower() then
						sendTo = charName
						validArg=true
						break;
					end
				end
				if not sendTo then 
					ExecAssist:alert("Unable to find Character "..nextArg); validArg = nil; 
					break; 
				end
			else
				if validArgs["+"][nextArg] then
					if nextArg == "+aw" then
						argT["isAcctWide"] = true
					elseif validArgs["+"][nextArg] then -- cheat to check for 3x at once
						argT["resetType"] = validArgs["+"][nextArg]
					end
				else
					ExecAssist:alert("Unrecognized argument: "..nextArg); validArg=nil					
				end
			end	
		else
			ExecAssist:alert("Unrecognized argument: "..nextArg); validArg=nil	
		end
	end

	return argT, sendTo, data, validArg
end
local function mkTaskExclusive(hTask, charName)
	hTask.defaultEnabled = false
		
	local charStem = ExecAssist.db.global.charStem[charName]
	if not charStem.agg[hTask.id] then charStem.agg[hTask.id] = {} end
	charStem.agg[hTask.id].userOverride = 2
end
function ExecAssist:doAddPurgableTask(aceTable, forceCurrentChar)
	local data = aceTable.input:sub(6):trim()
	local argT, sendTo, taskName, validArg = getArgTable(data)

	if validArg then
		local hTask = ExecAssist:getFreshTaskStem()
		if hTask then
			if taskName ~= "" then hTask.taskName = taskName end -- if no name, it will be default
			hTask.resetType = self.optValues.ResetTypes[ true and argT["resetType"] or 4 ]
			hTask.isAcctWide = argT["isAcctWide"]
			if sendTo or forceCurrentChar then mkTaskExclusive(hTask, forceCurrentChar and self.userCurrent or sendTo) end
		
			local groupStem = self.db.global.groupStem
			self:semiSmart_regrow(groupStem.agg[groupStem.cmdLineTarget].G) -- add to options table
	
			if self.db.char.useTaskWindow then self:UpdateWindow() end -- since refresh was suppressed in :AddTask()
	
			self:alert( ( (forceCurrentChar and L.personal.." " or "")..L.taskCreated):format(( true and ((taskName ~= nil and taskName ~="") and taskName or nil) or L.DefaultTaskName):cf("EAtan")))
		end
	end -- msg already delivered
end
function ExecAssist:doAddPersonalPurgableTask(aceTable)
	-- easy redirector to make default->sendTo items for the current user
	aceTable.input = aceTable.input:sub(2) -- doAdd assumes 6chr of task input
	self:doAddPurgableTask(aceTable, true)
end

function ExecAssist:reset_CmdLineTarget(hGroup, mayNotBeNil)
	local groupStem = self.db.global.groupStem
	
	if hGroup.id == groupStem.cmdLineTarget then 
		if not mayNotBeNil then -- mayNotBeNil is passed by command line reset ops to keep to user from accidentally unsetting a target
			groupStem.cmdLineTarget = nil
			hGroup.cmdLineTarget=false
		end
	else
		if groupStem.cmdLineTarget then
			groupStem.agg[groupStem.cmdLineTarget].cmdLineTarget=false -- tell old target they can take the night off
		end
		hGroup.cmdLineTarget = true							-- new sherrif in town
		groupStem.cmdLineTarget = hGroup.id			-- making it official
	end
	return groupStem.cmdLineTarget
end

function ExecAssist:doResetTargetGroup(aceTable)
	local groupName = aceTable.input:sub(10):trim()
	local groupName_lower = groupName:lower()

	local groupStem = self.db.global.groupStem
	for elementID, hElement in pairs(groupStem.agg) do
		if elementID:isGroup() and hElement.listName:lower() == groupName_lower then
		
			if self:reset_CmdLineTarget(hElement, true) then 
				self:alert( (L.cmdlinetargetsetto):format( hElement.listName:cf("EAtan")  ))
			else -- um...
			end

			return
		end
	end

	self:alert( (L.unabletofindgroup):format((groupName):cf("EAtan")))
end